(define-module (wip cc65)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix git-download)
  #:use-module (guix packages)
  #:use-module (guix build-system gnu)
  #:use-module (gnu packages))

(define-public cc65
  (package
    (name "cc65")
    (version "0.0.1")
    (source (origin
              (method git-fetch)
              (uri (git-reference
                (url "https://github.com/cc65/cc65.git")
                (commit "cbb2833c01a8db64931a7e1dca80736bb9f3f858")))
              (file-name (string-append name "-" version "-checkout"))
              (sha256
               (base32
                "0gwkk8azmk5kw3g8cmjqc1p6qm0lska3856c4xg8kn7ws5sbiyc1"))))
    (build-system gnu-build-system)
    (arguments
     `(#:phases
       (modify-phases %standard-phases
         (delete 'configure))))
    (native-inputs
     `())
    (inputs
     `())
    (synopsis "6502 Compiler")
    (description "Provides a C compiler for the MOS 6502 CPU.")
    (home-page "https://cc65.github.io/cc65/")
    (license #f))) ; FIXME
