
(define-module (wip cobol)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix download)
  #:use-module (guix packages)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages bison)
  #:use-module (gnu packages multiprecision)
  #:use-module (gnu packages databases)
  #:use-module (gnu packages flex)
  #:use-module (gnu packages ncurses)
  #:use-module (guix build-system gnu))

; libcob.so.4 runpath validation fails.
(define-public gnu-cobol
  (package
    (name "gnu-cobol")
    (version "2.0_rc-2")
    (source (origin
      (method url-fetch)
      (uri (string-append "https://sourceforge.net/projects/open-cobol/files/gnu-cobol/2.0/" name "-" version ".tar.gz/download"))
      (sha256
       (base32
        "1pj7mjnp3l76zvzrh1xa6d4kw3jkvzqh39sbf02kiinq4y65s7zj"))))
    (arguments
     `(#:configure-flags '("--enable-debug")
       #:phases
       (modify-phases %standard-phases
         (add-before 'configure 'setenv
           (lambda* (#:key outputs #:allow-other-keys)
             (let ((out (assoc-ref outputs "out")))
               (setenv "LDFLAGS"
                       (string-append "-Wl,-rpath="
                                      out
                                      "/lib")))))))) ; TODO --with-cc=
    (build-system gnu-build-system)
    (inputs
     `(("gmp" ,gmp)
       ("bdb" ,bdb)
       ("ncurses" ,ncurses)))
    (native-inputs
     `(("bison" ,bison-2.7)
       ("flex" ,flex)
       ("autoconf" ,autoconf))) ; for the tests (autom4te)
    ; libltdl not on Linux
    (home-page "https://sourceforge.net/projects/open-cobol/")
    (synopsis "COBOL")
    (description "A COBOL.")
    (license license:gpl3+))) ; FIXME
