;  129  sudo modprobe dummy
;    130  sudo ip link set dev dummy0 name eth0
;        133  sudo ip link set dev eth0 address 00:1f:16:1e:c7:9a
(define-module (wip ddca)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix hg-download)
  #:use-module (guix utils)
  #:use-module (guix build-system python)
  #:use-module (guix build-system gnu)
  #:use-module (guix gexp)
  #:use-module (gnu packages)
  #:use-module (gnu packages base)
  #:use-module (gnu packages cross-base)
  #:use-module (gnu packages compression)
  #:use-module (gnu packages elf)
  #:use-module (gnu packages ghostscript)
  #:use-module (gnu packages image)
  #:use-module (gnu packages tcl)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages xml))

;PATH="$PATH:/opt/Modelsim/modeltech/linux_x86_64/"
;export MGLS_LICENSE_FILE=/home/shus/backup/license/modelsim/license.dat

; https://gist.github.com/tejainece/1c5edf08482c587cefb2

;sudo modprobe dummy
;sudo ip link set dev dummy0 name eth0
;sudo ip link set dev eth0 address 00:00:00:00:00:00

;GRUB_CMDLINE_LINUX="net.ifnames=0 biosdevname=0"

(define-public glibc-2.23
  (package
    (inherit glibc)
    (version "2.23")
    (replacement #f)
    (source (origin
              (inherit (package-source glibc))
              (uri (string-append "mirror://gnu/glibc/glibc-"
                                  version ".tar.xz"))
              (sha256
               (base32
                "1s8krs3y2n6pzav7ic59dz41alqalphv7vww4138ag30wh0fpvwl"))
              (patches (search-patches "glibc-ldd-x86_64.patch"
                                       "glibc-versioned-locpath.patch"
                                       "glibc-o-largefile.patch"
                                       "glibc-vectorized-strcspn-guards.patch"
                                       "glibc-CVE-2017-1000366-pt1.patch"
                                       "glibc-CVE-2017-1000366-pt2.patch"
                                       "glibc-CVE-2017-1000366-pt3.patch"))))))

(define-public freetype
  (package
   (name "freetype")
   ;(replacement freetype/fixed)
   (version "2.5.0.1")
   (source (origin
            (method url-fetch)
            (uri (string-append "mirror://savannah/freetype/freetype-"
                                version ".tar.bz2"))
            (sha256 (base32
                     "1rgla7r7v0pn335li5w6qfy3kgzn75l45255njl7lmw9g6rybg2p"))))
   (build-system gnu-build-system)
   (native-inputs
    `(("pkg-config" ,pkg-config)
      ("which" ,which)))
   (propagated-inputs
    ;; These are all in the Requires.private field of freetype2.pc.
    ;; XXX: add harfbuzz.
    `(("libpng" ,libpng)
      ("zlib" ,zlib)))
   (arguments
    `(#:phases
      (modify-phases %standard-phases
       (add-after 'unpack 'setenv
         (lambda _
           (setenv "CONFIG_SHELL" (which "sh"))
           #t)))))
   (synopsis "Font rendering library")
   (description
    "Freetype is a library that can be used by applications to access the
contents of font files.  It provides a uniform interface to access font files.
It supports both bitmap and scalable formats, including TrueType, OpenType,
Type1, CID, CFF, Windows FON/FNT, X11 PCF, and others.  It supports high-speed
anti-aliased glyph bitmap generation with 256 gray levels.")
   (license license:freetype)           ; some files have other licenses
   (home-page "https://www.freetype.org/")))

(define-public fontconfig
  (package
   (name "fontconfig")
   (version "2.12.1")
   (source (origin
            (method url-fetch)
            (uri (string-append
                   "https://www.freedesktop.org/software/fontconfig/release/fontconfig-"
                   version ".tar.bz2"))
            (patches (search-patches "fontconfig-charwidth-symbol-conflict.patch"
                                     "fontconfig-path-max.patch"))
            (sha256 (base32
                     "1wy7svvp7df6bjpg1m5vizb3ngd7rhb20vpclv3x3qa71khs6jdl"))))
   (build-system gnu-build-system)
   (propagated-inputs `(("expat" ,expat)
                        ("freetype" ,freetype)))
   (inputs `(("gs-fonts" ,gs-fonts)))
   (native-inputs
      `(("pkg-config" ,pkg-config)))
   (arguments
    `(#:configure-flags
      (list "--with-cache-dir=/var/cache/fontconfig"
            ;; register gs-fonts as default fonts
            (string-append "--with-default-fonts="
                           (assoc-ref %build-inputs "gs-fonts")
                           "/share/fonts")

            ;; Register fonts from user and system profiles.
            (string-append "--with-add-fonts="
                           "~/.guix-profile/share/fonts,"
                           "/run/current-system/profile/share/fonts")

            ;; python is not actually needed
            "PYTHON=false")
      #:phases
      (modify-phases %standard-phases
        (add-after 'unpack 'fix-tests-for-freetype-2.7.1
          (lambda _
            (substitute* "test/run-test.sh"
              (("\\\| sort") "| cut -d' ' -f2 | sort"))
            #t))
        (replace 'install
                 (lambda _
                   ;; Don't try to create /var/cache/fontconfig.
                   (zero? (system* "make" "install"
                                   "fc_cachedir=$(TMPDIR)"
                                   "RUN_FC_CACHE_TEST=false")))))))
   (synopsis "Library for configuring and customizing font access")
   (description
    "Fontconfig can discover new fonts when installed automatically;
perform font name substitution, so that appropriate alternative fonts can
be selected if fonts are missing;
identify the set of fonts required to completely cover a set of languages;
have GUI configuration tools built as it uses an XML-based configuration file;
efficiently and quickly find needed fonts among the set of installed fonts;
be used in concert with the X Render Extension and FreeType to implement
high quality, anti-aliased and subpixel rendered text on a display.")
   ; The exact license is more X11-style than BSD-style.
   (license (license:non-copyleft "file://COPYING"
                       "See COPYING in the distribution."))
   (home-page "http://www.freedesktop.org/wiki/Software/fontconfig")))

;; See <http://geekwentfreak.com/tags/modelsim/>.
(define-public modelsim
  (package
    (name "modelsim")
    (version "10.2")
    (source
      (origin
        (method url-fetch)
        (uri (string-append "http://ee-classes.usc.edu/ee201/0lO100ooll11/f0r_UsC_oN1y/MSim_SE_10.2/install.linux"))
        (sha256
         (base32 "1g0f9qi9in4nfar23bsyq1img9051pv2zxakhflvbq19ljjbmr0q"))))
    (build-system gnu-build-system)
    (native-inputs
     `(("patchelf" ,patchelf)
       ("base" ,(origin
           (method url-fetch)
           (uri (string-append "http://ee-classes.usc.edu/ee201/0lO100ooll11/f0r_UsC_oN1y/MSim_SE_10.2/modelsim-base.mis"))
           (sha256
            (base32
             "0fz40izdq3f8qa2n86i087fpz2q6zpj1fabz9gkdcc97fx37clr8"))))
        ("docs" ,(origin
           (method url-fetch)
           (uri (string-append "http://ee-classes.usc.edu/ee201/0lO100ooll11/f0r_UsC_oN1y/MSim_SE_10.2/modelsim-docs.mis"))
            (sha256
            (base32
             "0bhklipkn5xa5299257sximiw7j41x1k9ab5l8paqhraawxz9a41"))))
        ("linux_x86_64" ,(origin
           (method url-fetch)
           (uri (string-append "http://ee-classes.usc.edu/ee201/0lO100ooll11/f0r_UsC_oN1y/MSim_SE_10.2/modelsim-gcc-linux_x86_64.mis"))
           (sha256
            (base32
             "1kmqz3jzmybqx23jzwzh27x5qjvazrs06wzq8p9jm9m9d70fvyzg"))))
         ("cross-libc" ,(cross-libc "i686-linux-gnu"))))
    (arguments
     `(#:phases
       (modify-phases %standard-phases
         (delete 'configure)
         (delete 'build)
         (delete 'check)
         (replace 'unpack
           (lambda* (#:key source inputs #:allow-other-keys)
             (copy-file source "install.linux")
             (copy-file (assoc-ref inputs "base") "modelsim-base.mis")
             (copy-file (assoc-ref inputs "docs") "modelsim-docs.mis")
             (copy-file (assoc-ref inputs "linux_x86_64") "modelsim-gcc-linux_x86_64.mis")
             #t))
         (replace 'install
           (lambda* (#:key inputs outputs #:allow-other-keys)
             (setenv "LD_LIBRARY_PATH" (string-append (assoc-ref inputs "cross-libc") "/lib"))
             (write (getenv "LD_LIBRARY_PATH"))
             (system* "chmod" "+x" "install.linux")
             ;patchelf --set-interpreter /gnu/store/xjrdzyazwp6yz7228qh8k1y8n3g9zm0z-glibc-cross-i686-linux-gnu-2.25/lib/ld-linux.so.2 a
             (zero? (system* "./install.linux")))))))
    (home-page "XXX")
    (synopsis "ModelSIM")
    (description "ModelSIM")
    (license license:bsd-3))) ; FIXME

