(define-module (wip embedded)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix git-download)
  #:use-module (guix packages)
  #:use-module (gnu packages cross-base)
  #:use-module (gnu packages embedded)
  #:use-module (guix build-system gnu))

(define-public rpi-open-firmware
  (package
    (name "rpi-open-firmware")
    (version "0.0.1")
    (source
      (origin
        (method git-fetch)
        (file-name (string-append name "-" version "-checkout"))
        (uri (git-reference
              (url "https://github.com/christinaa/rpi-open-firmware.git")
              (commit "a1d07fc1c951b3fd05e2fa3bee5538ecbdd126ed")))
        (sha256
         (base32
          "0g6fn235cpi7znl2yxx3whss1xk3b0r72j79blz375byvs8fzkiq"))))
    (build-system gnu-build-system)
    (arguments
     `(#:phases
       (modify-phases %standard-phases
         (delete 'configure))))
    (native-inputs
     `(("gcc-vc4" ,gcc-vc4)))
    (home-page "https://github.com/christinaa/rpi-open-firmware")
    (synopsis "Rpi-Open-Firmware")
    (description "Rpi-Open-Firmware.")
    ;; Special exception see <https://github.com/christinaa/rpi-open-firmware/issues/29>
    (license (list license:bsd-3 license:gpl2+)))) ; FIXME

