
(define-module (wip freac)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix hg-download)
  #:use-module (guix utils)
  #:use-module (guix build-system python)
  #:use-module (guix build-system gnu)
  #:use-module (guix gexp)
  #:use-module (gnu packages)
  #:use-module (gnu packages base)
  #:use-module (gnu packages compression)
  #:use-module (gnu packages databases)
  #:use-module (gnu packages libffi)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages ncurses)
  #:use-module (gnu packages tcl)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages python)
  #:use-module (gnu packages xml))

;; Requires: boca.
(define-public freac
  (package
    (name "freac")
    (version "1.0.28-20161129")
    (source
      (origin
        (method url-fetch)
        (uri (string-append "https://sourceforge.net/projects/bonkenc/files/snapshots/20161129/freac-20161129-linux-x64.tar.gz/download"))
        (file-name "frac-20161129-linux-x64.tar.gz")
        (sha256
          (base32
            "01m484v07al2jk3q6vck791d11mmng5lm3abf5dsnyayajahr871"))))
    (build-system gnu-build-system)
    (arguments
     `(#:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'chdir
           (lambda _
             (chdir "source/freac-20161129")
             #t)))))
    ; TODO inputs: libudev, gtk2
    (home-page "https://www.freac.org/")
    (synopsis "CD ripper")
    (description "Rips CDs.")
    (license license:gpl2))) ; FIXME check
