(define-module (wip java)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix utils)
  #:use-module (guix build-system ant)
  #:use-module (guix gexp)
  #:use-module (gnu packages)
  #:use-module (gnu packages java)
  #:use-module (gnu packages pkg-config))

;  JAVA_HOME="path to JDK 1.8"
;  JDK_16="path to JDK 1.6"
;  JDK_17="path to JDK 1.7"
;  JDK_18="path to JDK 1.8"

;; FIXME Unbundle Trove4j, args4j, asm, closure-compiler, dart, jshashtable, json, maven, pcollections, prototype, rhino, scala, trove
;ant -f update_dependencies.xml
;intellij-core is a part of command line compiler and contains only necessary APIs.
;idea-full is a full blown IntelliJ IDEA Community Edition to be used in the plugin module.
;ant -f build.xml
;which will build the binaries of the compiler and put them into the dist directory. You may need to increase the heap size for Ant using ANT_OPTS.
;OPTIONAL: Maven artifact distribution is built separately, go into libraries directory after building the compiler and run:
;./gradlew build install
;mvn install

; com.intellij.ant.Javac2
(define-public kotlin
  (package
    (name "kotlin")
    (version "1.1.2-2")
    (source (origin
              (method url-fetch)
              (uri (string-append "https://github.com/JetBrains/kotlin/archive/v" version ".tar.gz"))
              (file-name (string-append name "-" version ".tar.gz"))
              (sha256
               (base32
                "09ia4bic80kmcffjp86zpw6a814qad8msk788qwh3y32zsw62qy8"))))
    (build-system ant-build-system) ; Require ant 1.9.4
    (home-page "https://kotlinlang.org/")
    (synopsis "Kotlin Language")
    (description "Kotlin Language.")
    (license (list license:asl2.0))))

;; TODO unbundle XStream, ant, asm, eclipse, growl, gson, imgscalr, javahelp, javolution, jaxb, jaxen, jayatana, jdom, jgoodies, junit, kryo, log4j, microba, miglayout swing, nanoxml, oromatcher, picoContainer, sanselan, saxon, sqljet, svnkit, swingx, trove4j, winp, xerces, xmlrpc, yourkit
(define-public intellij-pycharm
  (package
    (name "intellij-pycharm")
    (version "172.2378")
    (source (origin
              (method url-fetch)
              (uri (string-append "https://github.com/JetBrains/intellij-community/archive/pycharm/" version ".tar.gz"))
              (file-name (string-append name "-" version ".tar.gz"))
              (sha256
               (base32
                "05d3gh916wpla1jmis3kak9anxi8biqcliw13iffci2lgs7dql6x"))))
    (build-system ant-build-system)
    (home-page "https://kotlinlang.org/") ; FIXME
    (synopsis "PyCharm IDE")
    (description "This PyCharm IDE.")
    (license (list license:asl2.0)))) ; FIXME

; TODO IDEA https://github.com/JetBrains/intellij-community/archive/idea/171.4694.9.tar.gz
; TODO appcode
; TODO clion
; TODO phpstorm (NO)

;; TODO ${project.home}/build/dependencies
;; FIXME git://git.jetbrains.org/idea/community.git and getPlugins.sh (Android plugin)
;; FIXME requires grade (and tries to download it from the internet)
(define-public intellij-idea
  (package
    (name "intellij-idea")
    ;(version "2017.3")
    (version "173.3984")
    (source (origin
              (method url-fetch)
              ;(uri (string-append "https://download-cf.jetbrains.com/idea/"
              ;                    "ideaIC-" version "-no-jdk.tar.gz"))
              (uri (string-append "https://github.com/JetBrains/intellij-community/archive/idea/" version ".tar.gz"))
              (file-name (string-append name "-" version ".tar.gz"))
              (sha256
               (base32
                "0q3m1d9gdmyqn6l7y71ra9yf2w4mi311cxkyjr740zz1av8fgyin"))))
    (build-system ant-build-system)
    ;(native-inputs
    ; `(("python" ,python)))
    ; TODO ruby, python-2, python.
    (arguments
     `(#:build-target "build"
       #:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'set-environment-up
           (lambda _
             (mkdir "/tmp/foo")
             (setenv "GRADLE_USER_HOME" "/tmp/foo")
             #t)))))
    (home-page "https://www.jetbrains.com/")
    (synopsis "IntelliJ IDEA IDE")
    (description "This package provides the IntelliJ IDEA IDE.")
    (license (list license:asl2.0))))

; TODO pycharm, TeamCity, Kotlin(!), YouTrack, DataGrip, Upsource, WebStorm
; https://github.com/JetBrains/intellij-community/archive/pycharm/181.1638.tar.gz
