;;; Copyright © 2016 Efraim Flashner <efraim@flashner.co.il>
;;;
;;; This file is an addendum to GNU Guix.
;;;
;;; GNU Guix is free software; you can redistribute it and/or modify it
;;; under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or (at
;;; your option) any later version.
;;;
;;; GNU Guix is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.

(define-module (wip messaging)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix download)
  #:use-module (guix packages)
  #:use-module (gnu packages python)
  #:use-module (guix build-system python))

(define-public synapse
  (package
    (name "synapse")
    (version "0.21.0")
    (source
      (origin
        (method url-fetch)
        (uri (string-append "https://github.com/matrix-org/synapse/archive/v" version ".tar.gz"))
        (sha256
         (base32
          "1djmxfc4899glf97247ayr3q2sbj4m304n64989aj3a62pqpg6xa"))))
    (build-system python-build-system)
    (arguments
     `(#:python ,python-2))
    (home-page "https://matrix.org/")
    (synopsis "Matrix Encrypted Federated Chat")
    (description "Matrix is encrypted federated chat.")
    (license license:asl2.0)))
