(define-module (wip navi)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix svn-download)
  #:use-module (guix utils)
  #:use-module (guix build-system gnu)
  #:use-module (gnu packages)
  #:use-module (gnu packages libffi)
  #:use-module (gnu packages avr)
  #:use-module (gnu packages python))

(define-public tss463aa
 (let ((revision 5886))
  (package
    (name "tss463aa")
    (version (string-append "4.7-" (number->string revision)))
    (source (origin
              (method svn-fetch)
              (uri (svn-reference
                    (url "http://svn.nomike.com/playground/trunk/Navi/TSS463AA")
                    (revision revision)))
              (sha256
               (base32
                "1ygyi7zvy8mrwb40a7vyabhgh19bl3j8ch65blvs1r2ddsl2kjp6"))
              (file-name (string-append name "-" version))))
    (arguments
      `(#:phases
        (modify-phases %standard-phases
          (delete 'configure)
          (add-after 'unpack 'chdir-and-fix
             (lambda* (#:key inputs #:allow-other-keys)
                (chdir "Arduino")
                (substitute* '("Makefile")
                  (("/usr/share/arduino") (string-append (assoc-ref inputs "arduino-makefile") "/share/arduino")))
                #t)))))
    ;(native-inputs
    ;  `(("arduino-makefile" ,arduino-makefile)))
    (build-system gnu-build-system)
    (synopsis "Navi TSS463AA VAN Bus Controller")
    (description "@code{tss463aa} is a library to connect to a TSS463AA VAN bus controller.")
    (home-page "https://metalab.at/wiki/Navi")
    (license license:gpl3+))))
