(define-module (wip ruststrap)
  #:use-module (gnu packages base)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages jemalloc)
  #:use-module (gnu packages llvm)
  #:use-module (gnu packages ocaml)
  #:use-module (gnu packages perl)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages python)
  #:use-module (gnu packages ssh)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages valgrind)
  #:use-module (gnu packages version-control)
  #:use-module (guix build-system cargo)
  #:use-module (guix build-system gnu)
  #:use-module (guix build-system trivial)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (ice-9 match)
  #:use-module (srfi srfi-26))

;; 6 years old
;; TODO try llvm 3.0 rc1 (not rc2)
;; TODO make it use 64 bit stdlib
(define-public rustboot
  (package
    (name "rustboot")
    (version "0.6")
    (source
      (origin
        (method git-fetch)
        (uri (git-reference
               (url "https://github.com/rust-lang/rust.git")
               (commit "ef75860a0a72f79f97216f8aaa5b388d98da6480")))
        (sha256
         (base32 "0jv51p42nmi5l7mwwp4qnw9p50z0aiw01yq386mz5shicpnppzp5"))
        (file-name (string-append name "-" version "-checkout"))))
    (build-system gnu-build-system)
    (arguments
     `(#:system "i686-linux"
       #:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'optionalize-curl
           (lambda _
             (substitute* "configure"
               (("probe_need CFG_CURL") "probe CFG_CURL")
;               (("3.0") "3.8.1")
)
             (substitute* "src/rustllvm/RustWrapper.cpp"
               (("llvm/Target/TargetSelect.h") "llvm/Support/TargetSelect.h")
               (("llvm/Target/TargetRegistry.h") "llvm/Support/TargetRegistry.h"))
             (substitute* "src/rustllvm/Passes2.cpp"
               (("llvm/Support/StandardPasses.h") "llvm/Transforms/IPO/PassManagerBuilder.h"))
             #t)))))
; Note: curl for ./src/etc/snapshot.py; ignore.
    (native-inputs
     `(("coreutils" ,coreutils) ; mkdir
       ("git" ,git)
       ("ocaml" ,ocaml)
       ("perl" ,perl) ; this dependency is very-little used (only used for getting rid of Windows-like paths). TODO remove dependency.
       ("python-2" ,python-2)
       ("valgrind" ,valgrind)
       ("which" ,which)))
    (inputs
     `(("llvm-3.5" ,llvm-3.5))) ; FIXME llvm-3.0
    (home-page "https://www.rust-lang.org/")
    (synopsis "Rust compiler written in OCaml")
    (description "This package provides a @command{rustc} compiler
written in Ocaml, which can in turn be used to build the final Rust compiler.")
    (license license:asl2.0)))
