
(define-module (wip sage)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix hg-download)
  #:use-module (guix utils)
  #:use-module (guix build-system python)
  #:use-module (guix build-system gnu)
  #:use-module (guix gexp)
  #:use-module (gnu packages)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages base)
  #:use-module (gnu packages compression)
  #:use-module (gnu packages databases)
  #:use-module (gnu packages libffi)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages m4)
  #:use-module (gnu packages ncurses)
  #:use-module (gnu packages perl)
  #:use-module (gnu packages tcl)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages python)
  #:use-module (gnu packages xml))

;; FIXME unbundle arb, atlas, boehm_gc, backports_ssl_match_hostname, boost_cropped, gzip2, cddlib, cephes, certifi, cliquer, conway_polynomials, cvxopt, cython, ...
(define-public sage
  (package
   (name "sage")
   (version "7.5.1")
   (source
     (origin
       (method url-fetch)
       (uri (string-append "http://sage.mirror.garr.it/mirrors/sage/src/sage-" version ".tar.gz"))
       (sha256
         (base32
           "0vkgyg8sp0h5qn7xgljx4zq5q28sl6yplsm18snb87q3wpl3ysmr"))))
   (build-system gnu-build-system)
   (arguments
    `(#:modules ((guix build utils) (guix build gnu-build-system))
      #:phases
      (modify-phases %standard-phases
        (add-after 'unpack 'setenv
          (lambda _
            (mkdir "/tmp/xx")
            (setenv "HOME" "/tmp/xx")
            (setenv "SAGE_INSTALL_GCC" "no")
            #t)))))
   (inputs
    `(
   ;; FIXME add openssl tk pyopenssl
   ;; TODO add numpy, scipy, matplotlib, sympy, maxima, gap, flint, r
))
   (native-inputs
    `( ; ("autoconf" ,autoconf)
      ("m4" ,m4)
      ("perl" ,perl) ; FIXME normal input?
   ;; FIXME add gfortran
   ;; FIXME add dvipng, ffmpeg, imagemagick, latex
))
   (home-page "https://www.sagemath.org/")
   (synopsis "Sage Math")
   (description "This packages contains Sage Math.")
   (license license:gpl3)))

