;;; Copyright © 2016 Efraim Flashner <efraim@flashner.co.il>
;;;
;;; This file is an addendum to GNU Guix.
;;;
;;; GNU Guix is free software; you can redistribute it and/or modify it
;;; under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or (at
;;; your option) any later version.
;;;
;;; GNU Guix is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.

(define-module (wip scala)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix download)
  #:use-module (guix packages)
  #:use-module (guix build-system ant)
  #:use-module (gnu packages python))

(define-public scala-bootstrap
  (package
    (name "scala")
    (version "1.4.0+4")
    (source
      (origin
        (method url-fetch)
        (uri (string-append "https://github.com/scala/scala/archive/"
                            version ".tar.gz"))
        (sha256
         (base32
          "1fi5kkgi59gd9nssy9zc86b8rki3m47pd29vc821jgsa89lgjqf5"))))
    (build-system ant-build-system)
    (home-page "https://github.com/scala/")
    (synopsis "Scala")
    (description "Scala.")
    (license license:agpl3+)))
